/**
 * Casebuilder widget that applies custom css to layout elements or pages.
 *
 * Licensed under MIT (license.txt).
 * 
 * @author ivojonker.nl
 */

define([
	"dojo/_base/declare",
	"dojo/json",
	"icm/base/BasePageWidget",
	"icm/base/_BaseWidget",
	"dojo/dom-class"
], function(declare, json, BasePageWidget, _BaseWidget, domClass){
	
	var previouslyAdded=[];

	return declare("ICMCSSAdapter.ICMCSSAdapter", [_BaseWidget, BasePageWidget], {
		templateString: "<div style='display:none'></div>",

		postCreate: function(){

			if ( this.widgetProperties.cssClassName && this.widgetProperties.cssClassName.trim().length>0){
				var targetNode = this.widgetProperties.addToPage ? this.page.domNode : this.getParent().domNode;
				domClass.add(targetNode, this.widgetProperties.cssClassName) ;
			}
			
			if (previouslyAdded.indexOf(this.widgetProperties.cssText)==-1){
				this._addCssToBody(this.widgetProperties.cssText);
				previouslyAdded.push(this.widgetProperties.cssText);
			}
		},
		
		_addCssToBody : function (css) {
			var head = document.head || document.getElementsByTagName('head')[0],
		    style = document.createElement('style');

			style.type = 'text/css';
			if (style.styleSheet){
			  style.styleSheet.cssText = css;
			} else {
			  style.appendChild(document.createTextNode(css));
			}
	
			head.appendChild(style);
		}
		
	});
});
